/**
 * Created by Glen on 2015/11/3.
 */
/**
 * native调用js方法统一入口，然后按照方法名称进行分发处理
 * @param method
 * @param data
 * @param callBackId
 */
var callbacks = {};

/**
 * Js调用native方法统一入口
 * @param method
 * @param data
 * @param callBack
 */
function execNative(method, data, callBack) {
    var jsCallbackId = null;
    if (callBack) {
        jsCallbackId = "" + new Date().getTime();
        callbacks[jsCallbackId] = callBack;
    }
    GMap.execNative(method, data, jsCallbackId);
}

/**
 * nativa方法执行完成后，通知js回调
 * @param jsCallbackId
 * @param data
 */
function execJSCall(jsCallbackId, data) {
    var callback = callbacks[jsCallbackId];
    if (callback) {
        callback(data);
        delete callbacks[jsCallbackId];
    }
}

function execJS(method, data, callBackId) {
    //创建函数对象，并调用
    var func = eval(method);
    var response = func(data);
    if (callBackId) {
        execNativeCall(callBackId, response);
    }
}

/**
 * js方法执行完成后，通知native回调
 * @param callBaciId
 * @param response
 */
function execNativeCall(callBaciId, response) {
    GMap.execNativeCall(callBaciId, response);
}
